<?php

use Bitrix\Main\Localization\Loc;
use Bitrix\Main\ModuleManager;

Loc::loadMessages(__FILE__);

class nikaverro_test extends CModule
{
    public $MODULE_ID = 'nikaverro.test';
    public $MODULE_VERSION;
    public $MODULE_VERSION_DATE;
    public $MODULE_NAME;
    public $MODULE_DESCRIPTION;
    public $PARTNER_URI;
    public $MODULE_GROUP_RIGHTS;

    public function __construct()
    {
        $arModuleVersion = [];

        include __DIR__ . '/version.php';

        if (is_array($arModuleVersion) && array_key_exists('VERSION', $arModuleVersion)) {
            $this->MODULE_VERSION = $arModuleVersion['VERSION'];
            $this->MODULE_VERSION_DATE = $arModuleVersion['VERSION_DATE'];
        }

        $this->MODULE_NAME = Loc::getMessage('nikaverro_test_module_name');
        $this->MODULE_DESCRIPTION = Loc::getMessage('nikaverro_test_module_description');
        $this->PARTNER_NAME = Loc::getMessage('nikaverro_test_partner_name');
        $this->PARTNER_URI = Loc::getMessage('nikaverro_test_partner_uri');
        $this->MODULE_GROUP_RIGHTS = 'N';
    }

     public  function InstallDB($arParams = [])
    {   global $DB, $APPLICATION;      
        //проверяем, есть ли таблицы
        $errors = false;
        //создаем таблицы, если они еще не существуют
        $errors = $DB->RunSQLBatch($_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/install/db/".strtolower($DB->type)."/install.sql");
        if (!empty($errors)){
            $APPLICATION->ThrowException(implode("", $errors));
            return false;
        }
       
        return true;
    }

     public  function UnInstallDB($arParams = [])
    {   global $DB, $DBType, $APPLICATION;
        //пока не удаляем таблицы
        if(array_key_exists("SAVEDATA", $arParams) and $arParams["SAVEDATA"] == "N"){
            $errors = false;
            $errors = $DB->RunSQLBatch($_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/install/db/".strtolower($DB->type)."/uninstall.sql");
            if (!empty($errors)){
                $APPLICATION->ThrowException(implode("", $errors));
                return false;
            }
        }
        
        return true;
    }

   

     public function InstallFiles($arParams = [])
    {
        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/admin")){
            if ($dir = opendir($p)){
                while (false !== $item = readdir($dir)){
                    if ($item == ".." || $item == "." || $item == "menu.php")
                        continue;
                    file_put_contents($file = $_SERVER['DOCUMENT_ROOT'].'/bitrix/admin/'.$this->MODULE_ID.'_'.$item,
                    '<'.'? require($_SERVER["DOCUMENT_ROOT"]."/local/modules/'.$this->MODULE_ID.'/admin/'.$item.'");?'.'>');
                }
                closedir($dir);
            }
        }
        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/install/components")){
            if ($dir = opendir($p)){
                while (false !== $item = readdir($dir)){
                    if ($item == ".." || $item == ".")
                        continue;
                    CopyDirFiles($p."/".$item, $_SERVER["DOCUMENT_ROOT"]."/bitrix/components/".$item, $ReWrite = True, $Recursive = True);
                }
                closedir($dir);
            }
        }
        //создаем папку для куков
        if(is_dir($_SERVER["DOCUMENT_ROOT"]."/upload/testfolder")){
            //ставим права
            chmod($_SERVER["DOCUMENT_ROOT"]."/upload/testfolder", 0755);
        }
        else{
            mkdir($_SERVER["DOCUMENT_ROOT"]."/upload/testfolder", 0755, true);
        }
        //копируем стили
        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/install/panel")){
            if ($dir = opendir($p)){
                while (false !== $item = readdir($dir)){
                    if ($item == ".." || $item == ".")
                        continue;
                    CopyDirFiles($p."/".$item, $_SERVER["DOCUMENT_ROOT"]."/bitrix/themes/.default/".$this->MODULE_ID."/".$item, $ReWrite = True, $Recursive = True);
                }
                closedir($dir);
            }
        }

        //копируем js
        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/install/js")){
            if ($dir = opendir($p)){
                while (false !== $item = readdir($dir)){
                    if ($item == ".." || $item == ".")
                        continue;
                    CopyDirFiles($p."/".$item, $_SERVER["DOCUMENT_ROOT"]."/bitrix/js/".$this->MODULE_ID."/".$item, $ReWrite = True, $Recursive = True);
                }
                closedir($dir);
            }
        }

        return true;
    }

    public function UnInstallFiles()
    {
        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/admin"))
        {
            if ($dir = opendir($p))
            {
                while (false !== $item = readdir($dir))
                {
                    if ($item == ".." || $item == ".")
                        continue;
                    unlink($_SERVER["DOCUMENT_ROOT"]."/bitrix/admin/".$this->MODULE_ID."_".$item);
                }
                closedir($dir);
            }
        }
        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/install/components"))
        {
            if ($dir = opendir($p))
            {
                while (false !== $item = readdir($dir))
                {
                    if ($item == ".." || $item == "." || !is_dir($p0 = $p."/".$item))
                        continue;

                    $dir0 = opendir($p0);
                    while (false !== $item0 = readdir($dir0))
                    {
                        if ($item0 == ".." || $item0 == ".")
                            continue;
                        DeleteDirFilesEx("/bitrix/components/".$item."/".$item0);
                    }
                    closedir($dir0);
                }
                closedir($dir);
            }
        }
        //удаляем куки
        if(is_dir($_SERVER["DOCUMENT_ROOT"]."/upload/testfolder")){                   
            DeleteDirFilesEx("/upload/testfolder");
        }
        //удаляем стили
        if(is_dir($_SERVER["DOCUMENT_ROOT"]."/bitrix/themes/.default/".$this->MODULE_ID)){                       
            DeleteDirFilesEx("/bitrix/themes/.default/".$this->MODULE_ID);
        }
        //удаляем js
        if(is_dir($_SERVER["DOCUMENT_ROOT"]."/bitrix/js/".$this->MODULE_ID)){                    
            DeleteDirFilesEx("/bitrix/js/".$this->MODULE_ID);
        }
        
        return true;

    }    

    public function InstallEvents()
    {
         //RegisterModuleDependences("main", "OnBuildGlobalMenu", $this->MODULE_ID, "CAlfateamWordstat", "OnBuildGlobalMenu");
        $eventManager = \Bitrix\Main\EventManager::getInstance(); 
        $eventManager->registerEventHandler(   "main",
           "OnProlog",
           $this->MODULE_ID,
           "nikaverro\\test\\MyClass",
           "onProlog"
        );

        return true;
    }

     public function UnInstallEvents()
    {
        //UnRegisterModuleDependences("main", "OnBuildGlobalMenu", $this->MODULE_ID, "CAlfateamWordstat", "OnBuildGlobalMenu");
        $eventManager = \Bitrix\Main\EventManager::getInstance(); 
        $eventManager->unRegisterEventHandler(   "main",
           "OnProlog",
           $this->MODULE_ID,
           "nikaverro\\test\\MyClass",
           "onProlog"
        );
        return true;
    }

    public function RegisterAgents() {

        $allowedAgents = [
            '\\nikaverro\\test\\MyClass::agent()' => [
                "MODULE_ID" => $this->MODULE_ID,
                "NAME" => '\\nikaverro\\test\\MyClass::agent();',
                "AGENT_INTERVAL" => 300,
                "IS_PERIOD" => "Y"
            ]
        ];

        $needToInstall = [];

        $res = CAgent::GetList([], ["MODULE_ID" => $this->MODULE_ID]);
        while ($arAgent = $res->Fetch()) {

            if (array_key_exists($arAgent["NAME"], $allowedAgents)) {
                unset($allowedAgents[$arAgent["NAME"]]);
            }
        }

        $agentObject = new \CAgent();

        foreach ($allowedAgents as $agent) {
            $agentObject->Add($agent);
        }

    }
    public function UnRegisterAgents() {
        \CAgent::RemoveModuleAgents($this->MODULE_ID);
    }    
        
    public function DoInstall()
    {
        //$this->InstallFiles();
        $this->InstallDB();
        //$this->InstallEvents();
        //$this->RegisterAgents();

        ModuleManager::registerModule($this->MODULE_ID);
    }

    
    /*public function DoUninstall() //удаляем модуль за 1 шаг
    {
        //$this->UnInstallFiles();
        //$this->UnInstallEvents();
        //$this->UnRegisterAgents();

        ModuleManager::unRegisterModule($this->MODULE_ID);
    }*/

    public function DoUninstall() //удаляем модуль за 2 шага - спрашиваем, сохранить ли таблицы
    {
        global $APPLICATION, $step; 
        $step = IntVal($step);
        if($step<2){    
            $APPLICATION->IncludeAdminFile(Loc::getMessage('nikaverro_test_partner_name'), $_SERVER["DOCUMENT_ROOT"]."/local/modules/".$this->MODULE_ID."/install/unstep1.php");
        }
        elseif(($step == 2) and (array_key_exists("nextstep", $_REQUEST))){                        
            //$this->UnInstallFiles();
            //$this->UnInstallEvents();
            //$this->UnRegisterAgents();

            ModuleManager::unRegisterModule($this->MODULE_ID);
            $this->UnInstallDB(["SAVEDATA" => $_REQUEST["savedata"]]);
        }       
    }  
    
    
}
